/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.present.wrapper;

import org.aspectj.bridge.IMessage;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.modules.guosen.goods.entity.Goods;
import org.springblade.modules.guosen.goods.service.IGoodsService;
import org.springblade.modules.guosen.medal.entity.Medal;
import org.springblade.modules.guosen.medal.service.IMedalService;
import org.springblade.modules.guosen.present.entity.Present;
import org.springblade.modules.guosen.present.vo.PresentVO;

import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-06-11
 */
public class PresentWrapper extends BaseEntityWrapper<Present, PresentVO>  {

	private IGoodsService goodsService;
	private IMedalService medalService;

	public PresentWrapper(IGoodsService goodsService, IMedalService medalService) {
		this.goodsService = goodsService;
		this.medalService = medalService;
	}

	public PresentWrapper() {
	}

	public static PresentWrapper build() {
		return new PresentWrapper();
 	}

	public static PresentWrapper build(IGoodsService goodsService,IMedalService medalService) {
		return new PresentWrapper(goodsService,medalService);
	}

	@Override
	public PresentVO entityVO(Present present) {
		PresentVO presentVO = Objects.requireNonNull(BeanUtil.copy(present, PresentVO.class));

		if (presentVO.getGiveMedalId() != null) {
			//查询赠送勋章的信息
			Medal medal = medalService.getById(presentVO.getGiveMedalId());
			presentVO.setGiveMedal(medal);
		}
		if (presentVO.getGoodsId() != null) {
			Goods goods = goodsService.getById(presentVO.getGoodsId());
			Medal medal = medalService.getById(goods.getDonateMedalId());
			presentVO.setGoodsName(goods.getGoodsName());
			presentVO.setGoodsPic(goods.getGoodsPic());
			presentVO.setGoodsPostAmount(goods.getGoodsPostAmount());
			presentVO.setDonateMedalId(goods.getDonateMedalId());
			presentVO.setDonateMedal(medal);
		}

		return presentVO;
	}

}
